diff -crN nakedmudv1.5/src/scripts/script_edit.c nakedmudv2.0/src/scripts/script_edit.c
*** nakedmudv1.5/src/scripts/script_edit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/script_edit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,240 ----
+ //*****************************************************************************
+ //
+ // script_edit.c
+ //
+ // This is a set of functions that come with scripts to allow them to be edited
+ // online in an OLC style. The functions for editing both scripts and script
+ // sets are included in here.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../socket.h"
+ #include "../character.h"
+ #include "../world.h"
+ #include "../zone.h"
+ 
+ #include "../olc2/olc.h"
+ #include "script.h"
+ #include "script_set.h"
+ #include "../editor/editor.h"
+ #include "script_editor.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // script set editing
+ //*****************************************************************************
+ #define SSEDIT_NEW      1
+ #define SSEDIT_DELETE   2
+ 
+ 
+ void ssedit_menu   (SOCKET_DATA *sock, SCRIPT_SET *set) {
+   LIST *scripts = scriptSetList(set, SCRIPT_TYPE_ANY);
+   SCRIPT_DATA *script = NULL;
+ 
+   // show all the scripts attached
+   text_to_buffer(sock, "Attached scripts:\r\n");
+   while((script = listPop(scripts)) != NULL)
+     send_to_socket(sock,
+ 		   "  {y[{c%4d{y]{w %-20s {c%s\r\n",
+ 		   scriptGetVnum(script), 
+ 		   scriptTypeName(scriptGetType(script)),
+ 		   scriptGetName(script));
+   deleteList(scripts);
+ 
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{cN{g) Attach new script\r\n"
+ 		 "{cD{g) Delete script\r\n"
+ 		 );
+ }
+ 
+ int  ssedit_chooser(SOCKET_DATA *sock, SCRIPT_SET *set, char option) {
+   switch(toupper(option)) {
+   case 'N':
+     text_to_buffer(sock, "Which script would you like to add (-1 for none): ");
+     return SSEDIT_NEW;
+   case 'D':
+     text_to_buffer(sock, "Which script would you like to delete (-1 for none): ");
+     return SSEDIT_DELETE;
+   default: return FALSE;
+   }
+ }
+ 
+ bool ssedit_parser (SOCKET_DATA *sock, SCRIPT_SET *set, int choice, 
+ 		    const char *arg) {
+   switch(choice) {
+   case SSEDIT_NEW: {
+     SCRIPT_DATA *script = worldGetScript(gameworld, atoi(arg));
+     if(script == NULL)
+       return FALSE;
+     scriptSetAdd(set, scriptGetVnum(script)); 
+     return TRUE;
+   }
+   case SSEDIT_DELETE:
+     scriptSetRemove(set, atoi(arg));
+     return TRUE;
+   default: return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // script editing
+ //*****************************************************************************
+ #define SCEDIT_NAME        1
+ #define SCEDIT_TYPE        2
+ #define SCEDIT_ARGS        3
+ #define SCEDIT_NARG        4
+ 
+ void scedit_menu   (SOCKET_DATA *sock, SCRIPT_DATA *script) {
+   send_to_socket(sock,
+ 		 "{g[{c%d{g]\r\n"
+ 		 "{g1) Name         : {c%s\r\n"
+ 		 "{g2) Script type  : {c%s\r\n"
+ 		 "{g3) Arguments    : {c%s\r\n"
+ 		 "{g4) Num. Argument: {c%d\r\n"
+ 		 "{g5) Script Code\r\n",
+ 		 scriptGetVnum(script),
+ 		 scriptGetName(script),
+ 		 scriptTypeName(scriptGetType(script)),
+ 		 (*scriptGetArgs(script) ? scriptGetArgs(script) : "<NONE>"),
+ 		 scriptGetNumArg(script));
+   script_display(sock, scriptGetCode(script), FALSE);
+ }
+ 
+ int  scedit_chooser(SOCKET_DATA *sock, SCRIPT_DATA *script, char option) {
+   switch(toupper(option)) {
+   case '1':
+     text_to_buffer(sock, "Enter a new name for the script: ");
+     return SCEDIT_NAME;
+   case '2':
+     olc_display_table(sock, scriptTypeName, NUM_SCRIPTS, 1);
+     return SCEDIT_TYPE;
+   case '3':
+     text_to_buffer(sock, "Enter new arguments: ");
+     return SCEDIT_ARGS;
+   case '5':
+     socketStartEditor(sock, script_editor,scriptGetCodeBuffer(script));
+     return MENU_NOCHOICE;
+   case '4':
+     switch(scriptGetType(script)) {
+       // 0 = triggers always
+       // 1 = triggers if the scriptor can see the char
+     case SCRIPT_TYPE_GIVE:
+     case SCRIPT_TYPE_ENTER:
+       send_to_socket(sock,
+ 		     "If the scriptor is a mob:\r\n"
+ 		     "  0 = always triggers\r\n"
+ 		     "  1 = triggers if the scriptor can see the char\r\n"
+ 		     "\r\n"
+ 		     "Enter choice : ");
+       return SCEDIT_NARG;
+ 
+     case SCRIPT_TYPE_COMMAND:
+       send_to_socket(sock,
+ 		     "Control for the actual MUD command:\r\n"
+ 		     "  0 = follow through with the MUD command\r\n"
+ 		     "  1 = cancel the MUD command.\r\n"
+ 		     "\r\n"
+ 		     "Enter choice : ");
+       return SCEDIT_NARG;
+ 
+     default:
+       send_to_socket(sock, 
+ 		     "This script type does not use numeric arguments.\r\n"
+ 		     "Enter choice (Q to quit) : ");
+       return MENU_NOCHOICE;
+     }
+ 
+   default:
+     return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool scedit_parser (SOCKET_DATA *sock, SCRIPT_DATA *script, int choice, 
+ 		    const char *arg) {
+   switch(choice) {
+   case SCEDIT_NAME:
+     scriptSetName(script, arg);
+     return TRUE;
+ 
+   case SCEDIT_ARGS:
+     scriptSetArgs(script, arg);
+     return TRUE;
+ 
+   case SCEDIT_NARG:
+     switch(scriptGetType(script)) {
+       // 0 = triggers always
+       // 1 = triggers if the scriptor can see the char
+     case SCRIPT_TYPE_GIVE:
+     case SCRIPT_TYPE_ENTER:
+     case SCRIPT_TYPE_EXIT:
+       scriptSetNumArg(script, MIN(1, MAX(0, atoi(arg))));
+       break;
+       // 0 = follow through with normal command
+       // 1 = cancel normal command
+     case SCRIPT_TYPE_COMMAND:
+       scriptSetNumArg(script, MIN(1, MAX(0, atoi(arg))));
+       break;
+     }
+     return TRUE;
+ 
+   case SCEDIT_TYPE: {
+     int num = atoi(arg);
+     if(num < 0 || num >= NUM_SCRIPTS)
+       return FALSE;
+     else {
+       scriptSetType(script, num);
+       // reset arguments
+       if(scriptGetArgs(script))
+ 	scriptSetArgs(script, "");
+       scriptSetNumArg(script, 0);
+       return TRUE;
+     }
+   }
+ 
+   default: 
+     return FALSE;
+   }
+ }
+ 
+ 
+ COMMAND(cmd_scedit) {
+   ZONE_DATA *zone;
+   SCRIPT_DATA *script;
+   script_vnum vnum;
+ 
+   // we need a vnum
+   if(!arg || !*arg)
+     send_to_char(ch, "Please supply the vnum of a script you wish to edit.\r\n");
+   else {
+     vnum = atoi(arg);
+ 
+     // make sure there is a corresponding zone ...
+     if((zone = worldZoneBounding(gameworld, vnum)) == NULL)
+       send_to_char(ch, "No zone exists that contains the given vnum.\r\n");
+     else if(!canEditZone(zone, ch))
+       send_to_char(ch, "You are not authorized to edit this zone.\r\n");  
+     else {
+       // find the script
+       script = zoneGetScript(zone, vnum);
+ 
+       // make our script
+       if(script == NULL) {
+ 	script = newScript();
+ 	scriptSetVnum(script, vnum);
+ 	scriptSetName(script, "An Unfinished Script");
+ 	scriptSetCode(script, "# script code goes here\n"
+ 		              "# make sure to comment it with pounds (#)\n");
+ 	zoneAddScript(zone, script);
+       }
+ 
+       do_olc(charGetSocket(ch), scedit_menu, scedit_chooser, scedit_parser,
+ 	     scriptCopy, scriptCopyTo, deleteScript, save_world, script);
+     }
+   }
+ }
diff -crN nakedmudv1.5/src/scripts/script_edit.d nakedmudv2.0/src/scripts/script_edit.d
*** nakedmudv1.5/src/scripts/script_edit.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/script_edit.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ scripts/script_edit.d scripts/script_edit.o: scripts/script_edit.c mud.h wrapsock.h property_table.h \
+   list.h map.h hashtable.h set.h buffer.h bitvector.h utils.h socket.h \
+   character.h world.h zone.h olc2/olc.h scripts/script.h \
+   scripts/script_set.h editor/editor.h scripts/script_editor.h
diff -crN nakedmudv1.5/src/scripts/script_editor.c nakedmudv2.0/src/scripts/script_editor.c
*** nakedmudv1.5/src/scripts/script_editor.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/script_editor.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,137 ----
+ //*****************************************************************************
+ //
+ // script_editor.c
+ //
+ // this is an extention of the basic script editor (/src/editor/editor.h) to
+ // be tailored for script editing. Provides syntax coloring and line number
+ // display, and auto indenting.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../socket.h"
+ #include "../auxiliary.h"
+ 
+ #include "../editor/editor.h"
+ #include "script_editor.h"
+ #include "script.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // auxiliary data and functions
+ //*****************************************************************************
+ typedef struct script_editor_aux_data {
+   int indent; // how far are we indented for our next line of code?
+ } SCRIPT_EDITOR_AUX_DATA;
+ 
+ SCRIPT_EDITOR_AUX_DATA *
+ newScriptEditorAuxData() {
+   SCRIPT_EDITOR_AUX_DATA *data = malloc(sizeof(SCRIPT_EDITOR_AUX_DATA));
+   data->indent = 0;
+   return data;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // local functions and data structures
+ //*****************************************************************************
+ EDITOR *script_editor = NULL;
+ 
+ 
+ //
+ // increase the indentation in our script by 2
+ void scriptEditorIndent(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   SCRIPT_EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "script_editor_aux_data");
+   data->indent += 2;
+ }
+ 
+ //
+ // decrease the indentation in our script by 2
+ void scriptEditorUndent(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   SCRIPT_EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "script_editor_aux_data");
+   data->indent -= 2;
+   if(data->indent < 0)
+     data->indent = 0;
+ }
+ 
+ //
+ // return what our current level of indenting is
+ int socketGetScriptEditorIndent(SOCKET_DATA *sock) {
+   SCRIPT_EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "script_editor_aux_data");
+   return data->indent;
+ }
+ 
+ //
+ // append new text to the script editor. Make sure we add the appropriate amount
+ // of spaces before the addition, and increment/decrement our indent as needed
+ void scriptEditorAppend(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   // if we're playing with else/elif/case, take down the input a notch
+   if(!strncmp(arg, "else:", 5) ||
+      !strncmp(arg, "elif ", 5) ||
+      !strncmp(arg, "case ", 5))
+     scriptEditorUndent(sock, NULL, NULL);
+ 
+   // add in our indents if neccessary
+   int indent = socketGetScriptEditorIndent(sock);
+   if(indent > 0) {
+     char fmt[20];
+     sprintf(fmt, "%%%ds", indent);
+     bprintf(buf, fmt, " ");
+   }
+ 
+   // cat the new line of code
+   bufferCat(buf, arg);
+   bufferCat(buf, "\n");
+ 
+   // see if we need to change our indent
+   int len = strlen(arg);
+   if(len > 0 && arg[len-1] == ':')
+     scriptEditorIndent(sock, NULL, NULL);
+ }
+ 
+ 
+ //
+ // list the script buffer to the socket, but do all of our syntax highlighting
+ void scriptEditorList(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   script_display(sock, bufferString(buf), TRUE);
+ }
+ 
+ 
+ //
+ // \r really screws up python; this function makes sure they're all stripped out
+ void scriptEditorFormat(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
+   bufferReplace(buf, "\r", "", TRUE);
+ }
+ 
+ //
+ // prepare our socket to use the script editor
+ void socketInitScriptEditor(SOCKET_DATA *sock) {
+   SCRIPT_EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "script_editor_aux_data");
+   data->indent = 0;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // implementation of script_editor.h
+ //*****************************************************************************
+ void init_script_editor() {
+   script_editor = newEditor();
+   editorSetAppend(script_editor, scriptEditorAppend);
+   editorSetInit(script_editor, socketInitScriptEditor);
+   editorAddCommand(script_editor, "v", "        Indent down the script editor",
+ 		   scriptEditorUndent);
+   editorAddCommand(script_editor, "^", "        Indent up the script editor",
+ 		   scriptEditorIndent);
+   editorAddCommand(script_editor, "l", "        List the current buffer contents",
+ 		   scriptEditorList);
+   editorAddCommand(script_editor, "f", "        Strips all bad characters out of the script",
+ 		   scriptEditorFormat);
+ 
+   auxiliariesInstall("script_editor_aux_data", 
+ 		     newAuxiliaryFuncs(AUXILIARY_TYPE_SOCKET,
+ 				       newScriptEditorAuxData, free,
+ 				       NULL, NULL, NULL, NULL));
+ }
diff -crN nakedmudv1.5/src/scripts/script_editor.d nakedmudv2.0/src/scripts/script_editor.d
*** nakedmudv1.5/src/scripts/script_editor.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/script_editor.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ scripts/script_editor.d scripts/script_editor.o: scripts/script_editor.c mud.h wrapsock.h \
+   property_table.h list.h map.h hashtable.h set.h buffer.h bitvector.h \
+   socket.h auxiliary.h editor/editor.h scripts/script_editor.h \
+   scripts/script.h
diff -crN nakedmudv1.5/src/scripts/script_editor.h nakedmudv2.0/src/scripts/script_editor.h
*** nakedmudv1.5/src/scripts/script_editor.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/script_editor.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,20 ----
+ #ifndef SCRIPT_EDITOR_H
+ #define SCRIPT_EDITOR_H
+ //*****************************************************************************
+ //
+ // script_editor.h
+ //
+ // this is an extention of the basic script editor (/src/editor/editor.h) to
+ // be tailored for script editing. Provides syntax coloring and line number
+ // display, and auto indenting.
+ //
+ //*****************************************************************************
+ 
+ extern EDITOR *script_editor;
+ 
+ //
+ // prepare the script editor for use
+ //
+ void init_script_editor();
+ 
+ #endif // SCRIPT_EDITOR_H
diff -crN nakedmudv1.5/src/scripts/script.h nakedmudv2.0/src/scripts/script.h
*** nakedmudv1.5/src/scripts/script.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/scripts/script.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 164,170 ****
  const char *scriptGetArgs(SCRIPT_DATA *script);
  const char *scriptGetName(SCRIPT_DATA *script);
  const char *scriptGetCode(SCRIPT_DATA *script);
! char      **scriptGetCodePtr(SCRIPT_DATA *script); // for text editing in olc
  
  void scriptSetVnum(SCRIPT_DATA *script, script_vnum vnum);
  void scriptSetType(SCRIPT_DATA *script, int type);
--- 164,170 ----
  const char *scriptGetArgs(SCRIPT_DATA *script);
  const char *scriptGetName(SCRIPT_DATA *script);
  const char *scriptGetCode(SCRIPT_DATA *script);
! BUFFER     *scriptGetCodeBuffer(SCRIPT_DATA *script);
  
  void scriptSetVnum(SCRIPT_DATA *script, script_vnum vnum);
  void scriptSetType(SCRIPT_DATA *script, int type);
***************
*** 186,191 ****
--- 186,207 ----
  void        charSetScripts(CHAR_DATA *mob, SCRIPT_SET *scripts);
  
  
+ //
+ // If OLC2 is installed, we'll want to be able to edit which scripts are
+ // on mobiles, objects, rooms, etc... that's what ssedit is for. scedit is
+ // used internally by CMD_SCEDIT to start up an online editor for scripts
+ //
+ #ifdef MODULE_OLC2
+ void ssedit_menu   (SOCKET_DATA *sock, SCRIPT_SET *set);
+ int  ssedit_chooser(SOCKET_DATA *sock, SCRIPT_SET *set, char option);
+ bool ssedit_parser (SOCKET_DATA *sock, SCRIPT_SET *set, int choice, 
+ 		    const char *arg);
+ void scedit_menu   (SOCKET_DATA *sock, SCRIPT_DATA *script);
+ int  scedit_chooser(SOCKET_DATA *sock, SCRIPT_DATA *script, char option);
+ bool scedit_parser (SOCKET_DATA *sock, SCRIPT_DATA *script, int choice, 
+ 		    const char *arg);
+ #endif // MODULE_OLC2
+ 
  
  
  //*****************************************************************************
diff -crN nakedmudv1.5/src/scripts/script_set.d nakedmudv2.0/src/scripts/script_set.d
*** nakedmudv1.5/src/scripts/script_set.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/script_set.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ scripts/script_set.d scripts/script_set.o: scripts/script_set.c mud.h wrapsock.h property_table.h \
+   list.h map.h hashtable.h set.h buffer.h bitvector.h utils.h world.h \
+   scripts/script_set.h scripts/script.h
diff -crN nakedmudv1.5/src/set.c nakedmudv2.0/src/set.c
*** nakedmudv1.5/src/set.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/set.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 11,24 ****
  #include "set.h"
  
  struct set_data {
!   int       num_buckets;
!   struct list **buckets;
  };
  
  struct set_iterator {
    int                curr_bucket; // the bucket number we're currently on
    struct set_data           *set; // the set we're iterating over
!   struct list_iterator *bucket_i; // the iterator for our current bucket
  };
  
  
--- 11,24 ----
  #include "set.h"
  
  struct set_data {
!   int    num_buckets;
!   LIST **buckets;
  };
  
  struct set_iterator {
    int                curr_bucket; // the bucket number we're currently on
    struct set_data           *set; // the set we're iterating over
!   LIST_ITERATOR *bucket_i;        // the iterator for our current bucket
  };
  
  
***************
*** 43,53 ****
  // implementation of set.h
  //
  //*****************************************************************************
! struct set_data *newSet(int num_buckets) {
    int i;
  
!   struct set_data *set = malloc(sizeof(struct set_data));
!   set->buckets = malloc(sizeof(struct list *) * num_buckets);
  
    // all NULL until they actually get a content
    for(i = 0; i < num_buckets; i++)
--- 43,53 ----
  // implementation of set.h
  //
  //*****************************************************************************
! SET *newSet(int num_buckets) {
    int i;
  
!   SET *set = malloc(sizeof(SET));
!   set->buckets = malloc(sizeof(LIST *) * num_buckets);
  
    // all NULL until they actually get a content
    for(i = 0; i < num_buckets; i++)
***************
*** 58,64 ****
  };
  
  
! void deleteSet(struct set_data *set) {
    int i;
  
    for(i = 0; i < set->num_buckets; i++)
--- 58,64 ----
  };
  
  
! void deleteSet(SET *set) {
    int i;
  
    for(i = 0; i < set->num_buckets; i++)
***************
*** 70,76 ****
  };
  
  
! void setPut(struct set_data *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
  
--- 70,76 ----
  };
  
  
! void setPut(SET *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
  
***************
*** 82,88 ****
  };
  
  
! void setRemove(struct set_data *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
  
--- 82,88 ----
  };
  
  
! void setRemove(SET *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
  
***************
*** 92,98 ****
  };
  
  
! int setIn(struct set_data *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
  
--- 92,98 ----
  };
  
  
! int setIn(SET *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
  
***************
*** 111,118 ****
  // this lets us do so.
  //
  //*****************************************************************************
! struct set_iterator *newSetIterator(struct set_data *S) {
!   struct set_iterator *I = malloc(sizeof(struct set_iterator));
  
    I->set = S;
    I->curr_bucket = 0;
--- 111,118 ----
  // this lets us do so.
  //
  //*****************************************************************************
! SET_ITERATOR *newSetIterator(SET *S) {
!   SET_ITERATOR *I = malloc(sizeof(SET_ITERATOR));
  
    I->set = S;
    I->curr_bucket = 0;
***************
*** 123,135 ****
  }
  
  
! void deleteSetIterator(struct set_iterator *I) {
    if(I->bucket_i) deleteListIterator(I->bucket_i);
    free(I);
  }
  
  
! void setIteratorReset(struct set_iterator *I) {
    int i;
  
    if(I->bucket_i) 
--- 123,135 ----
  }
  
  
! void deleteSetIterator(SET_ITERATOR *I) {
    if(I->bucket_i) deleteListIterator(I->bucket_i);
    free(I);
  }
  
  
! void setIteratorReset(SET_ITERATOR *I) {
    int i;
  
    if(I->bucket_i) 
***************
*** 151,157 ****
  }
  
  
! void *setIteratorNext(struct set_iterator *I) {
    // we have no iterator ... we have no elements left to iterate over!
    if(I->bucket_i == NULL)
      return NULL;
--- 151,157 ----
  }
  
  
! void *setIteratorNext(SET_ITERATOR *I) {
    // we have no iterator ... we have no elements left to iterate over!
    if(I->bucket_i == NULL)
      return NULL;
***************
*** 186,192 ****
  }
  
  
! void *setIteratorCurrent(struct set_iterator *I) {
    // we have no elements!
    if(I->bucket_i == NULL)
      return NULL;
--- 186,192 ----
  }
  
  
! void *setIteratorCurrent(SET_ITERATOR *I) {
    // we have no elements!
    if(I->bucket_i == NULL)
      return NULL;
diff -crN nakedmudv1.5/src/set.d nakedmudv2.0/src/set.d
*** nakedmudv1.5/src/set.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/set.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ set.d set.o: set.c list.h set.h
diff -crN nakedmudv1.5/src/set.h nakedmudv2.0/src/set.h
*** nakedmudv1.5/src/set.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/set.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 8,19 ****
  //
  //*****************************************************************************
  
! struct set_data  *newSet(int buckets);
! void           deleteSet(struct set_data *set);
! void              setPut(struct set_data *set, void *elem);
! void           setRemove(struct set_data *set, void *elem);
! int                setIn(struct set_data *set, void *elem);
  
  
  
  //*****************************************************************************
--- 8,21 ----
  //
  //*****************************************************************************
  
! typedef struct set_data                   SET;
! typedef struct set_iterator               SET_ITERATOR;
  
+ SET  *newSet   (int buckets);
+ void  deleteSet(SET *set);
+ void  setPut   (SET *set, void *elem);
+ void  setRemove(SET *set, void *elem);
+ int   setIn    (SET *set, void *elem);
  
  
  //*****************************************************************************
***************
*** 25,34 ****
  //
  //*****************************************************************************
  
! struct set_iterator *newSetIterator(struct set_data *S);
! void              deleteSetIterator(struct set_iterator *I);
! void               setIteratorReset(struct set_iterator *I);
! void               *setIteratorNext(struct set_iterator *I);
! void            *setIteratorCurrent(struct set_iterator *I);
  
  #endif // SET_H
--- 27,36 ----
  //
  //*****************************************************************************
  
! SET_ITERATOR *newSetIterator    (SET *S);
! void          deleteSetIterator (SET_ITERATOR *I);
! void          setIteratorReset  (SET_ITERATOR *I);
! void         *setIteratorNext   (SET_ITERATOR *I);
! void         *setIteratorCurrent(SET_ITERATOR *I);
  
  #endif // SET_H
diff -crN nakedmudv1.5/src/set_val/intallation nakedmudv2.0/src/set_val/intallation
*** nakedmudv1.5/src/set_val/intallation	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/set_val/intallation	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,5 ----
+ installation of the set_val module:
+ 
+ Install the module in the same way you would install any other module. However,
+ make sure that the set_val module is initialized before any other module that
+ tries to add a new set command!!
diff -crN nakedmudv1.5/src/set_val/module.mk nakedmudv2.0/src/set_val/module.mk
*** nakedmudv1.5/src/set_val/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/set_val/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ SRC += set_val/set_val.c
